﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using TicketSystem.ServiceContract;
using ServiceStack.ServiceClient.Web;

namespace ServiceStackClient
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Title = "ServiceStack Console Client";

            using (var client = new Soap11ServiceClient("http://localhost:30542"))
            {
                List<Ticket> queuedTickets = client.Send<List<Ticket>>(
                    new GetAllTicketsInQueueRequest()) ;
                if (queuedTickets != null)
                {
                    foreach (Ticket ticket in queuedTickets)
                    {
                        PrintTicket(ticket);
                    }
                }
            }
            
            Console.ReadKey();
        }

        private static void PrintTicket(Ticket ticket)
        {
            Console.WriteLine("Ticket ID: {0}", ticket.TicketId);
            Console.WriteLine("\tTable: {0}", ticket.TableNumber);
            Console.WriteLine("\tOrders: ");

            foreach (var order in ticket.Orders)
            {
                Console.WriteLine("\t\t{0}: {1}-{2}",
                    order.Category, order.MenuId, order.ItemDescription);
            }
        }
    }
}
