﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using TicketSystem.ServiceContract;
using ServiceStackServer.Translators;
using ServiceStack.ServiceInterface;

namespace ServiceStackServer
{
    public class TicketService : Service, ITicketService
    {
        private static readonly TicketSystem.TicketProcessor.TicketProcessor
            _ticketProcessor = new TicketSystem.TicketProcessor.TicketProcessor();

        public List<Ticket> Any(GetAllTicketsInQueueRequest request)
        {
            return _ticketProcessor.GetTicketsInQueue()
                .Select(TicketTranslator.TranslateTicket).ToList();
        }

        public void Any(QueueTicketRequest request)
        {
            _ticketProcessor.QueueTicket(
                TicketTranslator.TranslateTicket(request.Ticket));
        }

        public Ticket Any(PullTicketRequest request)
        {
            TicketSystem.TicketProcessor.Ticket nextTicket =
                _ticketProcessor.PullTicket();

            if (nextTicket != null)
            {
                return TicketTranslator.TranslateTicket(nextTicket);
            }

            return null;
        }
    }
}