﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace ServiceStackServer.Translators
{
    public static class TicketTranslator
    {
        public static TicketSystem.ServiceContract.Ticket TranslateTicket(
            TicketSystem.TicketProcessor.Ticket input)
        {
            return new TicketSystem.ServiceContract.Ticket
            {
                Orders = input.Orders.Select(TranslateOrder).ToList(),
                ServerId = input.ServerId,
                TableNumber = input.TableNumber,
                Timestamp = input.Timestamp,
                TicketId = input.TicketId
            };
        }

        public static TicketSystem.TicketProcessor.Ticket TranslateTicket(
            TicketSystem.ServiceContract.Ticket input)
        {
            return new TicketSystem.TicketProcessor.Ticket
            {
                Orders = input.Orders.Select(TranslateOrder).ToList(),
                ServerId = input.ServerId,
                TableNumber = input.TableNumber,
                Timestamp = input.Timestamp,
                TicketId = input.TicketId
            };
        }

        public static TicketSystem.ServiceContract.Order TranslateOrder(
            TicketSystem.TicketProcessor.Order input)
        {
            return new TicketSystem.ServiceContract.Order
            {
                Category = TranslateMenuCategory(input.Category),
                ItemDescription = input.ItemDescription,
                MenuId = input.MenuId
            };
        }

        public static TicketSystem.TicketProcessor.Order TranslateOrder(
            TicketSystem.ServiceContract.Order input)
        {
            return new TicketSystem.TicketProcessor.Order
            {
                Category = TranslateMenuCategory(input.Category),
                ItemDescription = input.ItemDescription,
                MenuId = input.MenuId
            };
        }

        public static TicketSystem.ServiceContract.MenuCategory TranslateMenuCategory(
            TicketSystem.TicketProcessor.MenuCategory input)
        {
            switch (input)
            {
                case TicketSystem.TicketProcessor.MenuCategory.Appetizer:
                    return TicketSystem.ServiceContract.MenuCategory.Appetizer;

                case TicketSystem.TicketProcessor.MenuCategory.Dessert:
                    return TicketSystem.ServiceContract.MenuCategory.Dessert;

                case TicketSystem.TicketProcessor.MenuCategory.MainCourse:
                    return TicketSystem.ServiceContract.MenuCategory.MainCourse;

                default:
                    return TicketSystem.ServiceContract.MenuCategory.Others;
            }
        }

        public static TicketSystem.TicketProcessor.MenuCategory TranslateMenuCategory(
            TicketSystem.ServiceContract.MenuCategory input)
        {
            switch (input)
            {
                case TicketSystem.ServiceContract.MenuCategory.Appetizer:
                    return TicketSystem.TicketProcessor.MenuCategory.Appetizer;

                case TicketSystem.ServiceContract.MenuCategory.Dessert:
                    return TicketSystem.TicketProcessor.MenuCategory.Dessert;

                case TicketSystem.ServiceContract.MenuCategory.MainCourse:
                    return TicketSystem.TicketProcessor.MenuCategory.MainCourse;

                default:
                    return TicketSystem.TicketProcessor.MenuCategory.Others;
            }
        }
    }
}