﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using TicketSystem.ServiceContract;
using WcfServer.Translators;

namespace WcfServer
{
    public class TicketService : ITicketService
    {
        private static readonly TicketSystem.TicketProcessor.TicketProcessor
            _ticketProcessor = new TicketSystem.TicketProcessor.TicketProcessor();

        public List<Ticket> GetAllTicketsInQueue()
        {
            return _ticketProcessor.GetTicketsInQueue()
                .Select(TicketTranslator.TranslateTicket).ToList();
        }

        public void QueueTicket(Ticket ticket)
        {
            _ticketProcessor.QueueTicket(
                TicketTranslator.TranslateTicket(ticket));
        }

        public Ticket PullTicket()
        {
            TicketSystem.TicketProcessor.Ticket nextTicket =
                _ticketProcessor.PullTicket();

            if (nextTicket != null)
            {
                return TicketTranslator.TranslateTicket(nextTicket);
            }

            return null;
        }
    }
}
