﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace TicketSystem.ServiceContract
{
    [ServiceContract]
    public interface ITicketService
    {
        [OperationContract]
        List<Ticket> GetAllTicketsInQueue();

        [OperationContract]
        void QueueTicket(Ticket ticket);

        [OperationContract]
        Ticket PullTicket();
    }
   
    [DataContract]
    public class Ticket
    {
        [DataMember]
        public int TicketId { get; set; }

        [DataMember]
        public int TableNumber { get; set; }

        [DataMember]
        public int ServerId { get; set; }

        [DataMember]
        public List<Order> Orders { get; set; }

        [DataMember]
        public DateTime Timestamp { get; set; }
    }

    [DataContract]
    public class Order
    {
        [DataMember]
        public MenuCategory Category { get; set; }

        [DataMember]
        public int MenuId { get; set; }

        [DataMember]
        public string ItemDescription { get; set; }
    }

    [DataContract]
    public enum MenuCategory
    {
        [EnumMember]
        Others = -1,

        [EnumMember]
        Appetizer = 0,

        [EnumMember]
        MainCourse = 1,

        [EnumMember]
        Dessert = 2
    }
}
