﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WcfClient.TicketService;

namespace WcfClient
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.Title = "WCF Console Client";

            using (TicketServiceClient client = new TicketServiceClient())
            {
                Ticket[] queuedTickets = client.GetAllTicketsInQueue();

                foreach (Ticket ticket in queuedTickets)
                {
                    PrintTicket(ticket);
                }
            }

            Console.ReadKey();
        }

        private static void PrintTicket(Ticket ticket)
        {
            Console.WriteLine("Ticket ID: {0}", ticket.TicketId);
            Console.WriteLine("\tTable: {0}", ticket.TableNumber);
            Console.WriteLine("\tOrders: ");

            foreach (var order in ticket.Orders)
            {
                Console.WriteLine("\t\t{0}: {1}-{2}", 
                    order.Category, order.MenuId, order.ItemDescription);
            }
        }
    }
}
